import { ClassConstructor } from '../class-transformer';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from '../types';
export declare class ClassTransformerForArray {
    static instance: ClassTransformerForArray;
    plainMapValue<T, TData>(classType: ClassConstructor<T>, array: TData[] | TData[][], options?: ArrayStorageOptions): Record<PropertyKey, unknown>;
    classMapValue<T, TObject extends Record<PropertyKey, unknown>>(classType: ClassConstructor<T>, object: TObject, options?: ArrayStorageOptions): unknown[];
    plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ClassTransformForArrayOptions & {
        isArray?: false;
    }): T;
    plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[][], options?: ClassTransformForArrayOptions & {
        isArray: true;
    }): T[];
    classToPlainArray<T extends object>(object: T, options?: ClassToPlainArrayOptions): unknown[];
    classToPlainArray<T extends object>(object: T[], options?: ClassToPlainArrayOptions): unknown[][];
    arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
        isArray?: false;
    }): Promise<T>;
    arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
        isArray: true;
    }): Promise<T[]>;
    arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
        isArray?: false;
    }): T;
    arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
        isArray: true;
    }): T[];
}
//# sourceMappingURL=ClassTransformerForArray.d.ts.map