"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayMember = void 0;
const storages_1 = require("../storages");
function ArrayMember(index, options) {
    if (typeof (index) !== 'number') {
        throw new TypeError(`index must be number: ${index}`);
    }
    return (target, propertyKey) => {
        var _a;
        if (!(options === null || options === void 0 ? void 0 : options.arrayMemberStorage)) {
            for (const eachStorage of (_a = storages_1.defaultArrayMemberClassStorage.get(target.constructor)) !== null && _a !== void 0 ? _a : []) {
                eachStorage.add(target.constructor, index, new storages_1.PropertyInfo(propertyKey, options));
            }
        }
        const storage = (options === null || options === void 0 ? void 0 : options.arrayMemberStorage) || storages_1.defaultArrayMemberStorage;
        storage.add(target.constructor, index, new storages_1.PropertyInfo(propertyKey, options));
    };
}
exports.ArrayMember = ArrayMember;
//# sourceMappingURL=ArrayMember.js.map