"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformClassToPlainArray = void 0;
const is_promise_1 = __importDefault(require("is-promise"));
const core_1 = require("../core");
function TransformClassToPlainArray(options) {
    return (target, propertyKey, descriptor) => {
        const method = descriptor.value;
        descriptor.value = function (...args) {
            const result = method.apply(this, args);
            return is_promise_1.default(result) ? result.then((v) => core_1.ClassTransformerForArray.instance.classToPlainArray(v, options)) : core_1.ClassTransformerForArray.instance.classToPlainArray(result, options);
        };
    };
}
exports.TransformClassToPlainArray = TransformClassToPlainArray;
//# sourceMappingURL=TransformClassToPlainArray.js.map