"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformPlainArrayToClass = void 0;
const is_promise_1 = __importDefault(require("is-promise"));
const core_1 = require("../core");
function TransformPlainArrayToClass(classType, options) {
    return (target, propertyKey, descriptor) => {
        const method = descriptor.value;
        descriptor.value = function (...args) {
            const result = method.apply(this, args);
            return is_promise_1.default(result) ? result.then((v) => core_1.ClassTransformerForArray.instance.plainArrayToClass(classType, v, options)) : core_1.ClassTransformerForArray.instance.plainArrayToClass(classType, result, options);
        };
    };
}
exports.TransformPlainArrayToClass = TransformPlainArrayToClass;
//# sourceMappingURL=TransformPlainArrayToClass.js.map