import { ClassConstructor } from './class-transformer';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from './types';
export * from './decorators';
export * from './storages';
export * from './exceptions';
export * from './types';
export * from './core';
export declare function plainMapValue<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ArrayStorageOptions): Record<PropertyKey, unknown>;
export declare function classMapValue<T, TObject extends Record<PropertyKey, unknown>>(classType: ClassConstructor<T>, object: TObject, options?: ArrayStorageOptions): unknown[];
export declare function plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[][], options?: ClassTransformForArrayOptions & {
    isArray: true;
}): T[];
export declare function plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ClassTransformForArrayOptions & {
    isArray?: false;
}): T;
export declare function classToPlainArray<T extends object>(object: T, options?: ClassToPlainArrayOptions): unknown[];
export declare function classToPlainArray<T extends object>(object: T[], options?: ClassToPlainArrayOptions): unknown[][];
export declare function arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): Promise<T>;
export declare function arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): Promise<T[]>;
export declare function arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): T;
export declare function arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): T[];
//# sourceMappingURL=index.d.ts.map